PROGRAM testparse_list

  USE errorhandling
  USE parse_list_mod

  implicit NONE

  CHARACTER(len=14) :: list1 = "one, two,three"
  CHARACTER(len=15) :: list2 = " one two three "
  CHARACTER(len=10) :: fname = "@test.list"

  CHARACTER(len=7), POINTER, DIMENSION(:) :: array1, array2, array3

  INTEGER i

  CALL parse_list(list1, array1, ",")

  CALL parse_list(list2, array2)

  CALL parse_list(fname, array3)

  IF( SIZE(array1) .NE. 3 ) THEN
     CALL error("WrongSize", "Wrong number of elements found in first list")
  END IF

  IF( SIZE(array2) .NE. 3 ) THEN
     CALL error("WrongSize", "Wrong number of elements found in second list")
  END IF

  IF( SIZE(array3) .NE. 3 ) THEN
     CALL error("WrongSize", "Wrong number of elements found in third list")
  END IF

  DO i = 1,3
     IF( array1(i) /= array2(i) .OR. array1(i) /= array3(i) )THEN
        WRITE(errstr, *) "Bad parsing of element ", i
        CALL error("BadParse")
     END IF
  END DO

END PROGRAM testparse_list
